--- u-boot-2011.06_original/common/cnc_util.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/common/cnc_util.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,1024 @@
+#include <rsa.h>
+#include "cnc_util.h"
+/*
+//\e[attr;3x;4ym
+#define RESET		0
+#define BRIGHT 		1
+#define DIM		    2
+#define UNDERLINE 	4
+#define BLINK		5
+#define REVERSE		7
+#define HIDDEN		8
+
+#define BLACK 		0
+#define RED		    1
+#define GREEN		2
+#define YELLOW		3
+#define BLUE		4
+#define MAGENTA		5
+#define CYAN		6
+#define	WHITE		7
+{ESC}[1m	High intensity.
+{ESC}[1;5m	High intensity and blink.
+{ESC}[30;46m	Black foreground, cyan background.
+{ESC}[m	Turn off all attributes.
+{ESC}[0m	Turn off all attributes.
+{ESC}[0;1;36m	Turn off all attributes, then turn on high-intensity cyan foreground.
+*/
+
+static struct spi_flash *cnc_spi_flash = NULL;
+
+char ColorBlack[sizeof xColorBlack] = xColorBlack;
+char ColorRed[sizeof  xColorRed ] = xColorRed ;
+char ColorGreen[sizeof xColorGreen  ] =  xColorGreen ;
+char ColorYellow[sizeof xColorYellow  ] =  xColorYellow ;
+char ColorBlue[sizeof xColorBlue  ] = xColorBlue  ;
+char ColorMagenta[sizeof xColorMagenta  ] = xColorMagenta  ;
+char ColorCyan[sizeof xColorCyan  ] =  xColorCyan ;
+char ColorWhite[sizeof xColorWhite  ] = xColorWhite  ;
+char ColorLightBlack[sizeof xColorLightBlack  ] = xColorLightBlack   ;
+char ColorLightRed[sizeof xColorLightRed  ] = xColorLightRed  ;
+char ColorLightGreen[sizeof  xColorLightGreen ] =  xColorLightGreen ;
+char ColorLightYellow[sizeof xColorLightYellow  ] = xColorLightYellow  ;
+char ColorLightBlue[sizeof xColorLightBlue  ] = xColorLightBlue  ;
+char ColorLightMagenta[sizeof xColorLightMagenta  ] = xColorLightMagenta  ;
+char ColorLightCyan[sizeof xColorLightCyan  ] = xColorLightCyan   ;
+char ColorLightWhite[sizeof  xColorLightWhite ] = xColorLightWhite  ;
+char ColorNormal[sizeof  xColorNormal ] = xColorNormal  ;
+char BlinkOn[sizeof xBlinkOn  ] = xBlinkOn  ;
+
+static int kluge_flag_to_fix_bug3394;
+
+extern int do_sflasher(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_sflashre(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_usb(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_fat_fsload(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_call_external_proc(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_cncflash(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_sflashwr(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_nand(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_mmcops(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_mem_md(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_flerase(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_mem_cmp(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_mem_cp(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_gpt(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[]);
+
+void ColorOff(void)
+{
+	ColorBlack[0]='\0';
+	ColorRed[0]='\0';
+	ColorGreen[0]='\0';
+	ColorYellow[0]='\0';
+	ColorBlue[0]='\0';
+	ColorMagenta[0]='\0';
+	ColorCyan[0]='\0';
+	ColorWhite[0]='\0';
+	ColorLightBlack[0]='\0';
+	ColorLightRed[0]='\0';
+	ColorLightGreen[0]='\0';
+	ColorLightYellow[0]='\0';
+	ColorLightBlue[0]='\0';
+	ColorLightMagenta[0]='\0';
+	ColorLightCyan[0]='\0';
+	ColorLightWhite[0]='\0';
+	ColorNormal[0]='\0';
+	BlinkOn[0]='\0';
+}
+
+void ColorOn(void)
+{
+	strcpy(ColorBlack,xColorBlack);
+	strcpy(ColorRed, xColorRed );
+	strcpy(ColorGreen,  xColorGreen );
+	strcpy(ColorYellow, xColorYellow );
+	strcpy(ColorBlue, xColorBlue  );
+	strcpy(ColorMagenta, xColorMagenta  );
+	strcpy(ColorCyan,xColorCyan );
+	strcpy(ColorWhite, xColorWhite)  ;
+	strcpy(ColorLightBlack, xColorLightBlack   );
+	strcpy(ColorLightRed, xColorLightRed  );
+	strcpy(ColorLightGreen, xColorLightGreen );
+	strcpy(ColorLightYellow, xColorLightYellow  );
+	strcpy(ColorLightBlue, xColorLightBlue  );
+	strcpy(ColorLightMagenta, xColorLightMagenta  );
+	strcpy(ColorLightCyan, xColorLightCyan   );
+	strcpy(ColorLightWhite, xColorLightWhite  );
+	strcpy(ColorNormal, xColorNormal  );
+	strcpy(BlinkOn,xBlinkOn  );
+}
+
+void Cnc_DumpMemory(UInt32 aStartAddress, UInt32 aCount)
+{
+	/* 	md.l 0x1000 0x100*/
+	char* pCmd[] = {  "md.l" , NULL ,  NULL  };
+	char TempCmd1[16];
+	char TempCmd2[16];
+
+	int status=0;
+	pCmd[1] =  TempCmd1; pCmd[2] =  TempCmd2;
+
+	sprintf(TempCmd1 , "0x%x", aStartAddress);
+	sprintf(TempCmd2 , "0x%x", aCount);
+	status = do_mem_md (NULL, 0, 3 , (char** const )pCmd );
+	status = status;
+}
+
+int cnc_NandRead(uint32_t aSrcAddressInFlash,  uint32_t aDstAddressInDram,  uint32_t alen)
+{
+	/* 		    nand     read   4000000 ${WORK_IMG} ${filesize}*/
+	char* pCmd[5] = {  "nand" , "read" ,  NULL ,  NULL     , NULL };
+	char TempCmd1[16];
+	char TempCmd2[16];
+	char TempCmd3[16];
+
+	int status=0;
+
+	sprintf(TempCmd1 , "0x%x", aDstAddressInDram); // Work_IMG : Flash address
+	sprintf(TempCmd2 , "0x%x", aSrcAddressInFlash); // DDR Ram address
+	sprintf(TempCmd3 , "0x%x", alen); // $(filesize)
+
+	debug (" NandRd : SrcFlashAddr : %x DstAddressDram : %x len : %x\n",
+			aSrcAddressInFlash, aDstAddressInDram, alen);
+
+	pCmd[2] =  TempCmd1; pCmd[3] =  TempCmd2; pCmd[4] =  TempCmd3;
+
+	if (aSrcAddressInFlash & 0x1FFFF)
+	{
+		/* NAND offset is not a multiple of the block size, do the kluge */
+		kluge_flag_to_fix_bug3394 = 1;
+	}
+
+	status = do_nand(NULL, 0, 5, pCmd);
+	kluge_flag_to_fix_bug3394 = 0;
+	if ( 0 != status )
+	{
+		status = -1;
+		printf("ERROR: fail to read nand secure sector\n");
+	}
+	return status;
+}
+
+int cnc_EMMCRead(uint32_t aSrcAddressInFlash,  uint32_t aDstAddressInDram,  uint32_t alen)
+{
+	/* 		    nand     read   4000000 ${WORK_IMG} ${filesize}*/
+	char* pCmd[5] = {  "mmc" , "read" ,  NULL ,  NULL     , NULL };
+	char TempCmd1[16];
+	char TempCmd2[16];
+	char TempCmd3[16];
+
+	int status=0;
+
+	sprintf(TempCmd1 , "0x%x", aDstAddressInDram); // Work_IMG : Flash address
+	sprintf(TempCmd2 , "0x%x", aSrcAddressInFlash >> 9); // DDR Ram address
+	sprintf(TempCmd3 , "0x%x", ((alen + 511) >> 9)); // $(filesize)
+
+	debug (" eMMCRd : SrcFlashAddr : %x DstAddressDram : %x len : %x\n",
+			aSrcAddressInFlash, aDstAddressInDram, alen);
+
+	pCmd[2] =  TempCmd1; pCmd[3] =  TempCmd2; pCmd[4] =  TempCmd3;
+
+	if (aSrcAddressInFlash & 0x1FF)
+	{
+		/* eMMC offset is not a multiple of the block size, do the kluge?? */
+		//		kluge_flag_to_fix_bug3394 = 1;
+	}
+
+	status = do_mmcops(NULL, 0, 5, pCmd);
+	//	kluge_flag_to_fix_bug3394 = 0;
+	if ( 0 != status )
+	{
+		status = -1;
+		printf("ERROR: fail to read eMMC secure sector\n");
+	}
+	return status;
+}
+int cnc_NorErase(UInt32 aFlashStartAddress, UInt32 aLength)
+{
+	return 0;
+	/*
+	   int status=0;
+	   char argv0[20];
+	   char argv1[20];
+	   char argv2[20];
+	   char *argv[] = { argv0,
+	   argv1,
+	   argv2
+	   };
+
+	   sprintf( argv0, "%s", "erase" );
+	   sprintf( argv1, "%X", aFlashStartAddress );
+	   sprintf( argv2, "%X", aFlashStartAddress + aLength  );
+
+	//printf("running:%s %s %s\n", argv0, argv1, argv2);
+	//status=do_flerase(NULL, 0,sizeof(argv)/sizeof(char *), argv);
+	//printf("Status - %s\n", (status ==0) ? "OK" : "Error");
+	return status;
+	*/
+}
+int cnc_NorVerify(UInt32 aDdrStartAddress, UInt32 aFlashStartAddress, UInt32 aLength)
+{
+	int status;
+	char argv0[20];
+	char argv1[20];
+	char argv2[20];
+	char argv3[20];
+
+	char *argv[] = { argv0,
+		argv1,
+		argv2,
+		argv3
+	};
+
+	sprintf( argv0, "%s", "cmp.b" );
+	sprintf( argv1, "%X", aDdrStartAddress );
+	sprintf( argv2, "%X", aFlashStartAddress);
+	sprintf( argv3, "%X", aLength);
+
+	//printf("running:%s %s %s %s\n", argv0, argv1, argv2,argv3);
+	status=do_mem_cmp(NULL, 0,sizeof(argv)/sizeof(char *), argv);
+	//printf("Status - %s\n", (status ==0) ? "OK" : "Error");
+	return status;
+}
+int cnc_NorRead(UInt32 aFlashSourceAddress, UInt32 aDdrDestinationAddress,  UInt32 aLength)
+{
+	int status;
+	char argv0[20];
+	char argv1[20];
+	char argv2[20];
+	char argv3[20];
+	char *argv[] = { argv0,
+		argv1,
+		argv2,
+		argv3
+	};
+
+	sprintf( argv0, "%s", "cp.b" );
+	sprintf( argv1, "%X", aFlashSourceAddress );
+	sprintf( argv2, "%X", aDdrDestinationAddress );
+	sprintf( argv3, "%X", aLength );
+
+	//printf("running:%s %s %s %s\n", argv0, argv1, argv2, argv3);
+	status = do_mem_cp(NULL, 0,sizeof(argv)/sizeof(char *), argv);
+	//printf("Status - %s\n", (status ==0) ? "OK" : "Error");
+	return status;
+}
+int cnc_NorWrite(UInt32 aDdrSourceAddress, UInt32 aFlashDestinationAddress, UInt32 aLength)
+{
+	int status;
+	char argv0[20]={0};
+	char argv1[20]={0};
+	char argv2[20]={0};
+	char argv3[20]={0};
+	char *argv[] = { argv0,
+		argv1,
+		argv2,
+		argv3
+	};
+	sprintf( argv0, "%s", "cp.b" );
+	sprintf( argv1, "%X", aDdrSourceAddress );
+	sprintf( argv2, "%X", aFlashDestinationAddress );
+	sprintf( argv3, "%X", aLength );
+
+	//printf("running:%s %s %s %s\n", argv0, argv1, argv2, argv3);
+	status = do_mem_cp(NULL, 0,sizeof(argv)/sizeof(char *), argv);
+	//printf("Status - %s\n", (status ==0) ? "OK" : "Error");
+	return status;
+}
+int cnc_NandErase(UInt32 aFlashStartAddress, UInt32 aLength , UInt32 aEraseSpread)
+{
+	int status;
+	char argv0[20];
+	char argv1[20];
+	char argv2[20];
+	char argv3[20];
+	char *argv[] = { argv0,
+		argv1,
+		argv2,
+		argv3
+	};
+
+	sprintf( argv0, "%s", "nand" );
+	sprintf( argv1, "%s",  (aEraseSpread==1) ? "erase.spread" : "erase" );
+	sprintf( argv2, "%X", aFlashStartAddress );
+	sprintf( argv3, "%X", aLength );
+
+	//printf("running:%s %s %s %s\n", argv0, argv1, argv2, argv3);
+	status = do_nand( NULL, 0, sizeof(argv)/sizeof(char *), argv );
+	//printf("Status - %s\n", (status ==0) ? "OK" : "Error");
+	return status;
+}
+
+int cnc_EMMCRescan(void)
+{
+	char argv0[20]={0};
+	char argv1[20]={0};
+	char *argv[] = { argv0,argv1};
+	int status;
+
+	sprintf( argv0, "%s", "mmc" );
+	sprintf( argv1, "%s", "rescan" );
+
+	printf("running:%s %s\n", argv0, argv1);
+	status = do_mmcops( NULL, 0, sizeof(argv)/sizeof(char *), argv );
+	return status;
+}
+
+int cnc_CreatGPTPartitionTable(ImagePartitionList_t *pt_list)
+{
+	int cur_pt_num = 0;
+	char argv0[20]={0};
+	char argv1[20]={0};
+	char argv2[20]={0};
+	char argv3[20]={0};
+	char argv4[1024]={0};
+	char temp_argv[1024]={0};
+	char temp_uuid[40]={0};
+	char *argv[] = { argv0,argv1,argv2,argv3,argv4};
+	int status;
+	int first_emmc_pt = 1;
+	setenv("emmc0", "10000000-0000-0000-1310-000000000000");
+	sprintf( argv4, "%s", "uuid_disk=10000000-0000-0000-1310-000000000000;");
+	for(cur_pt_num = 0; cur_pt_num < pt_list->mNoOfPartition; cur_pt_num++){
+		if(0 == strcmp(pt_list->mImagePartitionList[cur_pt_num].mMtdId, "emmc")){
+			//			printf("index = %d, %s, 0x%x\n",cur_pt_num, pt_list->mImagePartitionList[cur_pt_num].mPartionName, pt_list->mImagePartitionList[cur_pt_num].mLength);
+			sprintf(temp_uuid, "10000000-0000-0000-1310-0000000000%2.2d", cur_pt_num+1);
+			setenv(pt_list->mImagePartitionList[cur_pt_num].mPartionName, temp_uuid);
+			if(first_emmc_pt){
+				sprintf(temp_argv,"uuid=%s,name=%s,size=%dMiB,start=1MiB;", temp_uuid, pt_list->mImagePartitionList[cur_pt_num].mPartionName, pt_list->mImagePartitionList[cur_pt_num].mLength/0x100000);
+				first_emmc_pt =0;
+			}
+			else{
+				sprintf(temp_argv,"uuid=%s,name=%s,size=%dMiB;", temp_uuid, pt_list->mImagePartitionList[cur_pt_num].mPartionName, pt_list->mImagePartitionList[cur_pt_num].mLength/0x100000);
+			}
+			strcat(argv4,temp_argv);
+			memset(temp_uuid,0,sizeof(temp_uuid));
+		}
+	}
+
+	sprintf( argv0, "%s", "gpt" );
+	sprintf( argv1, "%s", "write" );
+	sprintf( argv2, "%s", "mmc" );
+	sprintf( argv3, "%s", "0" );
+	//	sprintf( argv4, "%s", "uuid_disk=${emmc0};uuid=${blob},name=blob,size=1MiB,start=1MiB;uuid=${splash},name=splash,size=16MiB;uuid=${uboot_f},name=uboot_f,size=1MiB;uuid=${uboot},name=uboot,size=1MiB;uuid=${kernel_f},name=kernel_f,size=3MiB;uuid=${kernel},name=kernel,size=3MiB;uuid=${rootfs_f},name=rootfs_f,size=80MiB;uuid=${rootfs},name=rootfs,size=80MiB;uuid=${conf},name=conf,size=20MiB;uuid=${datafs},name=datafs,size=80MiB");
+	//	printf("running:%s %s %s,%s,%s\n", argv0, argv1,argv2,argv3,argv4);
+	status = do_gpt( NULL, 0, sizeof(argv)/sizeof(char *), argv );
+	return status;
+}
+
+int cnc_EMMCWrite(UInt32 aDdrSourceAddress, UInt32 aFlashDestinationAddress, UInt32 aLength,
+		cnc_ImageType aImageType )
+{
+	//image_header_t *hdr;
+	int status;
+	char argv0[20]={0};
+	char argv1[20]={0};
+	char argv2[20]={0};
+	char argv3[20]={0};
+	char argv4[20]={0};
+	char *argv[] = { argv0,
+		argv1,
+		argv2,
+		argv3,
+		argv4
+	};
+	sprintf( argv0, "%s", "mmc" );
+	sprintf( argv1, "%s", "write" );
+
+#if 0
+	hdr = (image_header_t *) aDdrSourceAddress;
+	switch (hdr->ih_type)
+	{
+		//------------------
+		case IH_TYPE_KERNEL:
+		case IH_TYPE_RAMDISK:
+			{
+				sprintf(argv1, "%s", "write.jffs2" );
+			}
+			break;
+			//-----------------
+		case IH_TYPE_FIRMWARE:
+		default:
+			{
+				sprintf( argv1, "%s", "write" );
+			}
+			//------------------
+	}
+#endif
+
+	sprintf( argv2, "%X", aDdrSourceAddress );
+	sprintf( argv3, "%X", aFlashDestinationAddress >> 9 );
+	sprintf( argv4, "%X", ((aLength + 511) >> 9) );
+
+	printf("running:%s %s %s %s %s\n", argv0, argv1, argv2, argv3, argv4 );
+	status = do_mmcops( NULL, 0, sizeof(argv)/sizeof(char *), argv );
+	//printf("Status - %s\n", (status ==0) ? "OK" : "Error");
+	return status;
+}
+
+int cnc_EMMCWrite2(UInt32 aDdrSourceAddress, UInt32 aFlashDestinationAddress, UInt32 aLength,
+		cnc_ImageType aImageType )
+{
+	//image_header_t *hdr;
+	int status = -1;
+	int count = 0, offset = 0;
+	char argv0[20]={0};
+	char argv1[20]={0};
+	char argv2[20]={0};
+	char argv3[20]={0};
+	char argv4[20]={0};
+	char *argv[] = { argv0,
+		argv1,
+		argv2,
+		argv3,
+		argv4
+	};
+	sprintf( argv0, "%s", "mmc" );
+	sprintf( argv1, "%s", "write" );
+	aLength += 511;
+	while (aLength > 0 )
+	{
+		count = min(aLength,128*1024 );
+		sprintf( argv2, "%X", aDdrSourceAddress + offset);
+		sprintf( argv3, "%X", (aFlashDestinationAddress + offset)>> 9 );
+		if(count>>9)
+			sprintf( argv4, "%X", (count >> 9) );
+
+		printf("running:%s %s %s %s %s\n", argv0, argv1, argv2, argv3, argv4 );
+		status = do_mmcops( NULL, 0, sizeof(argv)/sizeof(char *), argv );
+		if(-1 == status)
+			break;
+
+		aLength -= count;
+		offset +=count;
+	}
+	//printf("Status - %s\n", (status ==0) ? "OK" : "Error");
+	return status;
+}
+int cnc_NandWrite(UInt32 aDdrSourceAddress, UInt32 aFlashDestinationAddress, UInt32 aLength,
+		cnc_ImageType aImageType )
+{
+	//image_header_t *hdr;
+	int status;
+	char argv0[20]={0};
+	char argv1[20]={0};
+	char argv2[20]={0};
+	char argv3[20]={0};
+	char argv4[20]={0};
+	char *argv[] = { argv0,
+		argv1,
+		argv2,
+		argv3,
+		argv4
+	};
+	sprintf( argv0, "%s", "nand" );
+	sprintf( argv1, "%s", "write" );
+
+#if 0
+	hdr = (image_header_t *) aDdrSourceAddress;
+	switch (hdr->ih_type)
+	{
+		//------------------
+		case IH_TYPE_KERNEL:
+		case IH_TYPE_RAMDISK:
+			{
+				sprintf(argv1, "%s", "write.jffs2" );
+			}
+			break;
+			//-----------------
+		case IH_TYPE_FIRMWARE:
+		default:
+			{
+				sprintf( argv1, "%s", "write" );
+			}
+			//------------------
+	}
+#endif
+
+	switch (aImageType)
+	{
+		case KERNEL:sprintf(argv1, "%s", "write" );break;
+		case RAMDISK:sprintf(argv1, "%s", "write" );break;
+		case JFFS2:sprintf(argv1, "%s", "write.jffs2" );break;
+		default:
+		case RAW:sprintf( argv1, "%s", "write" ); break;
+	}
+
+	sprintf( argv2, "%X", aDdrSourceAddress );
+	sprintf( argv3, "%X", aFlashDestinationAddress );
+	sprintf( argv4, "%X", aLength );
+
+	//printf("running:%s %s %s %s %s\n", argv0, argv1, argv2, argv3, argv4 );
+	status = do_nand( NULL, 0, sizeof(argv)/sizeof(char *), argv );
+	//printf("Status - %s\n", (status ==0) ? "OK" : "Error");
+	return status;
+}
+int cnc_EMMCVerify(UInt32 aDdrStartAddress, UInt32 aFlashStartAddress, UInt32 aLength)
+{
+	int status=-1;
+	char TempBuf[128*1024];
+	UInt32 Offset=0;
+	UInt32 Count;
+	while (aLength > 0 )
+	{
+		Count = min(aLength,sizeof(TempBuf) );
+		status =  cnc_EMMCRead( aFlashStartAddress + Offset,(UInt32) TempBuf, Count);
+		if ( 0 == memcmp((UInt8*)TempBuf, (UInt8*)(aDdrStartAddress + Offset), Count) )
+		{
+			Offset = Offset + Count;
+			aLength = aLength - Count;
+		}
+		else
+		{
+			int i=0;
+			for(i=0;i<Count;i++)
+			{
+				if (TempBuf[i] != * ((UInt8*)(aDdrStartAddress)) )
+				{
+					break;
+				}
+			}
+			printf("%sERROR: eMMC verify fails at address %08x\n%s", ColorRed , aFlashStartAddress + i, ColorNormal );
+			status=-1;
+			return status;
+		}
+	}
+	return status;
+}
+
+int cnc_EMMCVerify2(UInt32 aDdrStartAddress, UInt32 aFlashStartAddress, UInt32 aLength)
+{
+	int status=-1;
+	UInt32 Offset=0;
+
+	status =  cnc_EMMCRead( aFlashStartAddress + Offset,(UInt32) (0x18000000), aLength);
+	if ( 0 == memcmp((UInt8*)(0x18000000), (UInt8*)(aDdrStartAddress + Offset), aLength) )
+	{
+		status = 0;
+	}
+
+	return status;
+}
+
+int cnc_NandVerify(UInt32 aDdrStartAddress, UInt32 aFlashStartAddress, UInt32 aLength)
+{
+	int status=-1;
+	char TempBuf[128*1024];
+	UInt32 Offset=0;
+	UInt32 Count;
+	while (aLength > 0 )
+	{
+		Count = min(aLength,sizeof(TempBuf) );
+		status =  cnc_NandRead( aFlashStartAddress + Offset,(UInt32) TempBuf, Count);
+		if ( 0 == memcmp((UInt8*)TempBuf, (UInt8*)(aDdrStartAddress + Offset), Count) )
+		{
+			Offset = Offset + Count;
+			aLength = aLength - Count;
+		}
+		else
+		{
+			int i=0;
+			for(i=0;i<Count;i++)
+			{
+				if (TempBuf[i] != * ((UInt8*)(aDdrStartAddress)) )
+				{
+					break;
+				}
+			}
+			printf("%sERROR: NAND verify fails at address %08x\n%s", ColorRed , aFlashStartAddress + i, ColorNormal );
+			status=-1;
+			return status;
+		}
+	}
+	return status;
+}
+int cnc_SpiVerify(UInt32 aDdrStartAddress, UInt32 aFlashStartAddress, UInt32 aLength)
+{
+	int status=-1;
+	char TempBuf[128*1024];
+	UInt32 Offset=0;
+	UInt32 Count;
+	while (aLength > 0 )
+	{
+		Count = min(aLength,sizeof(TempBuf) );
+		status =  cnc_SpiRead( aFlashStartAddress + Offset,(UInt32) TempBuf, Count);
+		if ( 0 == memcmp((UInt8*)TempBuf, (UInt8*)(aDdrStartAddress +Offset), Count) )
+		{
+			Offset = Offset + Count;
+			aLength = aLength - Count;
+		}
+		else
+		{
+			int i=0;
+			for(i=0;i<Count;i++)
+			{
+				if (TempBuf[i] != * ((UInt8*)(aDdrStartAddress)) )
+				{
+					break;
+				}
+			}
+			printf( "%sERROR: SPI verify fails at address %08x\n%s" , ColorRed , aFlashStartAddress + i, ColorNormal );
+			status=-1;
+			return status;
+		}
+	}
+	return status;
+}
+int cnc_SpiWrite(UInt32 aDdrSourceAddress, UInt32 aFlashDestinationAddress, UInt32 aLength)
+{
+	if(!cnc_spi_flash){
+		cnc_spi_flash = spi_flash_probe(0, 0, CONFIG_SF_DEFAULT_SPEED, SPI_MODE_3);
+		if(!cnc_spi_flash) return 1;
+	}
+	return spi_flash_write(cnc_spi_flash, aFlashDestinationAddress, aLength, (const void *)aDdrSourceAddress);
+}
+int cnc_SpiErase(UInt32 aFlashStartAddress, UInt32 aLength)
+{
+	if(!cnc_spi_flash){
+		cnc_spi_flash = spi_flash_probe(0, 0, CONFIG_SF_DEFAULT_SPEED, SPI_MODE_3);
+		if(!cnc_spi_flash) return 1;
+	}
+	return spi_flash_erase(cnc_spi_flash, aFlashStartAddress, aLength);
+}
+int cnc_SpiRead(UInt32 aFlashSourceAddress, UInt32 aDdrDestinationAddress,  UInt32 aLength)
+{
+	if(!cnc_spi_flash){
+		cnc_spi_flash = spi_flash_probe(0, 0, CONFIG_SF_DEFAULT_SPEED, SPI_MODE_3);
+		if(!cnc_spi_flash) return 1;
+	}
+	return spi_flash_read(cnc_spi_flash, aFlashSourceAddress, aLength, (void *)aDdrDestinationAddress);
+}
+//-------------------------------------------------------------------------------
+int cnc_UsbStart(void)
+{
+	const char *pStep1[] = { "usb", "start"};
+	return do_usb ( NULL, 0, sizeof(pStep1)/sizeof(const char*) ,(char** const ) pStep1);
+}
+int cnc_UsbStop(void)
+{
+	const char *pStep7[] = { "usb", "stop"};
+	return do_usb ( NULL, 0, sizeof(pStep7)/sizeof(const char*) , (char** const )pStep7);
+}
+int cnc_LoadFileFromUsb(const char* pFileName, UInt32 aAddress, UInt32 * apFileSize)
+{
+	int status;
+	char DDR_STORAGE_ADDRESS[12]={0};
+	char filesize[12]={0};
+	const char *pStep2[] = { "fatload", "usb" , "0", DDR_STORAGE_ADDRESS , pFileName };
+
+	sprintf(DDR_STORAGE_ADDRESS,"%x", aAddress);
+
+	status = cnc_UsbStart();
+	if (status != 0 )
+	{
+		printf("ERROR: fail to mount USB drive, aborting...\n");
+		return -4;
+	}
+
+	status = do_fat_fsload( NULL, 0, sizeof(pStep2)/sizeof(const char*) ,(char** const ) pStep2);
+	if (status != 0 )
+	{
+		return -1;
+	}
+	strncpy(filesize, getenv("filesize"), sizeof(filesize) );
+	*apFileSize = simple_strtol( filesize, NULL,16);
+	if (*apFileSize < 1 )
+	{
+		printf("ERROR: File Error, count < 1, aborting...\n");
+		return -3;
+	}
+
+	status = cnc_UsbStop();
+	return status;
+}
+
+
+int Cnc_InPlaceDecryptOnlyImage(UInt32 aSrcDstAddress, UInt32 aLength)
+{
+	//"call_external_proc" , "DVU_" , "crypto" , "0x00000000", "0x00000000", "0x00000000" "deconly""
+	int status;
+
+	char argv0[20];
+	char argv1[8];
+	char argv2[8];
+	char argv3[16];
+	char argv4[16];
+	char argv5[16];
+	char argv6[16];
+
+	char *argv[] = { argv0,
+		argv1,
+		argv2,
+		argv3,
+		argv4,
+		argv5,
+		argv6
+	};
+
+	sprintf( argv0, "%s", "call_external_proc" );
+	sprintf( argv1, "%s", "DVU_" );
+	sprintf( argv2, "%s", "crypto" );
+	sprintf( argv3, "%08X", aSrcDstAddress );
+	sprintf( argv4, "%08X", aSrcDstAddress  );
+	sprintf( argv5, "%08X", aLength  );
+	sprintf( argv6, "%s", "deconly"  );
+
+	//printf("running:%s %s %s %s %s %s %s\n", argv0, argv1, argv2, argv3, argv4, argv5,argv6);
+	status=do_call_external_proc(NULL, 0,sizeof(argv)/sizeof(char *),(char** const ) argv);
+	//printf("Status - %s\n", (status ==0) ? "OK" : "Error");
+	return status;
+}
+
+int Cnc_InPlaceDecryptOnlyImage_AES(UInt8 *KeyLadder, UInt32 aSrcDstAddress, UInt32 aLength)
+{
+	int status;
+
+	char argv0[20];
+	char argv1[8];
+	char argv2[8];
+	char argv3[16];
+	char argv4[16];
+	char argv5[16];
+
+	char *argv[] = { argv0,
+		argv1,
+		argv2,
+		argv3,
+		argv4,
+		argv5,
+	};
+
+	sprintf( argv0, "%s", "call_external_proc" );
+	sprintf( argv1, "%s", "DVU_" );
+	sprintf( argv2, "%s", "dec_aes" );
+	sprintf( argv3, "%08X", (unsigned int)KeyLadder );
+	sprintf( argv4, "%08X", aSrcDstAddress  );
+	sprintf( argv5, "%08X", aLength  );
+
+	//printf("running:%s %s %s %s %s %s %s\n", argv0, argv1, argv2, argv3, argv4, argv5,argv6);
+	status=do_call_external_proc(NULL, 0,sizeof(argv)/sizeof(char *),(char** const ) argv);
+	//printf("Status - %s\n", (status ==0) ? "OK" : "Error");
+	return status;
+}
+
+int Cnc_DecryptImage(UInt32 aSourceAddress, UInt32 aDestinationAddress, UInt32 aLength)
+{
+	//"call_external_proc" , "DVU_" , "crypto" , "0x00000000", "0x00000000", "0x00000000""
+	int status;
+
+	char argv0[20];
+	char argv1[8];
+	char argv2[8];
+	char argv3[16];
+	char argv4[16];
+	char argv5[16];
+
+	char *argv[] = { argv0,
+		argv1,
+		argv2,
+		argv3,
+		argv4,
+		argv5
+	};
+
+	sprintf( argv0, "%s", "call_external_proc" );
+	sprintf( argv1, "%s", "DVU_" );
+	sprintf( argv2, "%s", "crypto" );
+	sprintf( argv3, "%08X", aSourceAddress );
+	sprintf( argv4, "%08X", aDestinationAddress  );
+	sprintf( argv5, "%08X", aLength  );
+
+	//printf("running:%s %s %s %s %s %s\n", argv0, argv1, argv2, argv3, argv4, argv5);
+	status=do_call_external_proc(NULL, 0,sizeof(argv)/sizeof(char *), (char** const )argv);
+	//printf("Status - %s\n", (status ==0) ? "OK" : "Error");
+
+	return status;
+}
+int Cnc_DecryptImageGetHash(UInt32 aSourceAddress, UInt32 aDestinationAddress, UInt32 aLength,
+		UInt8* apHashBuf, int aHasBufLength)
+{
+	int status;
+
+	char argv0[20];
+	char argv1[8];
+	char argv2[8];
+	char argv3[16];
+	char argv4[16];
+	char argv5[16];
+	char argv6[16];
+
+	char *argv[] = { argv0,
+		argv1,
+		argv2,
+		argv3,
+		argv4,
+		argv5,
+		argv6
+	};
+
+	sprintf( argv0, "%s", "call_external_proc" );
+	sprintf( argv1, "%s", "DVU_" );
+	sprintf( argv2, "%s", "crypto" );
+	sprintf( argv3, "%08X", aSourceAddress );
+	sprintf( argv4, "%08X", aDestinationAddress  );
+	sprintf( argv5, "%08X", aLength  );
+	sprintf( argv6, "%08X", (UInt32) apHashBuf  );
+
+
+	//debug(ColorRed "running:%s %s %s %s %s %s %s\n" ColorNormal , argv0, argv1, argv2, argv3, argv4, argv5, argv6);
+	status=do_call_external_proc(NULL, 0,sizeof(argv)/sizeof(char *),(char** const ) argv);
+	//printf("Status - %s\n", (status ==0) ? "OK" : "Error");
+
+	//Cnc_DumpMemory(apHashBuf, aHasBufLength/sizeof(int) );
+
+	return status;
+}
+
+int cnc_Read_MtdPartition(const char *apMtdID, const char* apMtdPartitionName, UInt32 aDestinationAddress, UInt32 aLength /* 0xFFFFFFFF - to read comple region */ )
+{
+	int status;
+
+	char argv0[16];
+	char argv1[16];
+	char argv2[16];
+	char argv3[16];
+	char argv4[16];
+	char argv5[16];
+
+	char *argv[] = { argv0,
+		argv1,
+		argv2,
+		argv3,
+		argv4,
+		argv5
+	};
+
+	sprintf( argv0, "%s", "cncflash" );
+	sprintf( argv1, "%s", "read" );
+	sprintf( argv2, "%s", apMtdID );
+	sprintf( argv3, "%s", apMtdPartitionName );
+	sprintf( argv4, "%08X", aDestinationAddress  );
+	sprintf( argv5, "%08X", aLength  );
+
+	if ( 0xFFFFFFFF == aLength)
+	{
+		status = do_cncflash(NULL, 0, 5,(char** const ) argv);
+	}
+	else
+	{
+		status = do_cncflash(NULL, 0, 6, (char** const )argv);
+	}
+	return status;
+}
+
+/*
+ * Perform RSA verification on an image using a hybrid hashing input, No SW hashing here.
+ */
+int Cnc_ImgHybRsa_Verify (UInt8 hash[32], UInt32 asignAddress, UInt8 *publicKey)
+{
+	debug (" Uploading Public key ... \n");
+
+	/* Do hash of i/p Image */
+	UpdateExternalRSAKey(publicKey) ; // considered 2048 will generate 256 byte of public key only
+
+	printf ( "%s Verifying Image RSA signature... %s",ColorYellow, ColorNormal);
+
+	// debug only
+	debug ("sign buf addr %x\n", asignAddress);
+
+	int rt = HybridSignatureVerify( hash, (unsigned char *)asignAddress, RSA_PKCS_V15);
+
+	if (rt == 0)
+	{
+		printf ( "%s OK.\n%s" , ColorGreen, ColorNormal);
+	}
+	else
+	{
+		printf ( "%sFailed! Invalid Image.\n%s" , ColorRed, ColorNormal);
+		return -1;
+	}
+
+	return 0;
+}
+
+extern int otp_read_sha256(unsigned int *sha256);
+
+/*
+ *  Perform RSA verification on an image (deprecated)
+ */
+int ImgRsa_Verify (uint32_t aImgAddress, uint32_t aLen, uint32_t asignAddress, cnc_ImageType imageType)
+{
+	unsigned char Hash[32];
+	unsigned char OTP_Hash[32];
+
+	debug (" Uploading Public key ... \n");
+
+	/* Do hash of i/p Image */
+	if (imageType == RAW)
+	{
+		UpdateExternalRSAKey(blob_pkey) ;
+	}
+	else
+	{
+		UpdateExternalRSAKey(pkey) ; // considered 2048 will generate 256 byte of public key only
+	}
+
+	printf ( "%s Verifying Image RSA signature... %s",ColorYellow, ColorNormal);
+
+	// debug only
+	debug ("Img buf addr %x :: Img len : %x :: sign buf addr %x\n", aImgAddress, aLen, asignAddress);
+
+	int rt = SignatureVerify((unsigned char *)aImgAddress, aLen,
+			(unsigned char *)asignAddress, Hash, RSA_PKCS_V21);
+	if (rt == 0)
+	{
+		if (imageType == RAW)
+		{
+			otp_read_sha256((unsigned int*)OTP_Hash);
+			if (!memcmp(Hash, OTP_Hash, 32))
+			{
+				printf ( "%s OK.\n%s" , ColorGreen, ColorNormal);
+			}
+			else
+			{
+				printf ( "%sFailed! Hash mismatch, Invalid Blob.\n%s" , ColorRed, ColorNormal);
+				return -1;
+			}
+		}
+		else
+		{
+			printf ( "%s OK.\n%s" , ColorGreen, ColorNormal);
+		}
+	}
+	else
+	{
+		printf ( "%sFailed! Invalid Image.\n%s" , ColorRed, ColorNormal);
+		return -1;
+	}
+
+	return 0;
+}
+
+#define HW_REG_READ(addr)           (*((volatile unsigned int *)(addr)))
+#define SECURITY_CFG_ADDR           0xfffff010
+
+//returns 1 - if it is enabled.
+//returns 0 - if it is not enabled.
+unsigned int SecHWGetRSAEnable(void)
+{
+	unsigned int ret;
+	ret = HW_REG_READ(SECURITY_CFG_ADDR);
+	ret = (ret >> 3) & 0x1;
+	return ret ^ 0x1;
+}
+
+int ProgramAndVerify2Spi(UInt32 aDdrAddress, UInt32 aFlashAddress, UInt32 aLength )
+{
+	int Status = cnc_SpiErase(aFlashAddress, aLength); if( 0 != Status) return Status;
+	Status = cnc_SpiWrite(aDdrAddress , aFlashAddress, aLength); if( 0 != Status) return Status;
+	Status = cnc_SpiVerify(aDdrAddress, aFlashAddress, aLength);
+	if ( 0 == Status)
+	{
+		printf("%sSPI is programmed and verified successfully\n%s", ColorGreen, ColorNormal);
+	}
+	else
+	{
+		printf("%sERROR:Fail to verify SPI with programmed data, please check your hardware\n%s", ColorRed, ColorNormal);
+	}
+	return Status;
+}
+
+int ProgramAndVerify2Nand(UInt32 aDdrAddress, UInt32 aFlashAddress, UInt32 aLength)
+{
+	int Status = cnc_NandErase(aFlashAddress, aLength, 1); if( 0 != Status) return Status;
+	Status = cnc_NandWrite(aDdrAddress, aFlashAddress, aLength, RAW ); if( 0 != Status) return Status;
+	Status = cnc_NandVerify(aDdrAddress, aFlashAddress, aLength);
+	if ( 0 == Status)
+	{
+		printf("%sNAND is programmed and verified successfully\n%s", ColorGreen, ColorNormal);
+	}
+	else
+	{
+		printf("%sERROR:Fail to verify NAND with programmed data, please check your hardware\n%s", ColorRed, ColorNormal);
+	}
+	return Status;
+}
+
+int ProgramAndVerify2EMMC(UInt32 aDdrAddress, UInt32 aFlashAddress, UInt32 aLength)
+{
+	int Status;
+	//	Status = cnc_EMMCErase(aFlashAddress, aLength, 1); if( 0 != Status) return Status;
+	Status = cnc_EMMCWrite(aDdrAddress, aFlashAddress, aLength, RAW ); if( 0 != Status) return Status;
+	Status = cnc_EMMCVerify(aDdrAddress, aFlashAddress, aLength);
+	if ( 0 == Status)
+	{
+		printf("%seMMC is programmed and verified successfully\n%s", ColorGreen, ColorNormal);
+	}
+	else
+	{
+		printf("%sERROR:Fail to verify eMMC with programmed data, please check your hardware\n%s", ColorRed, ColorNormal);
+	}
+	return Status;
+}
+
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/command.c u-boot-2011.06/common/command.c
--- u-boot-2011.06_original/common/command.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/common/command.c	2014-07-29 17:28:38.819972000 +0800
@@ -142,6 +142,8 @@
 
 int cmd_usage(cmd_tbl_t *cmdtp)
 {
+	if (cmdtp == NULL ) return -1;
+	
 	printf("%s - %s\n\n", cmdtp->name, cmdtp->usage);
 
 #ifdef	CONFIG_SYS_LONGHELP
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/exports.c u-boot-2011.06/common/exports.c
--- u-boot-2011.06_original/common/exports.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/common/exports.c	2014-07-29 17:28:38.819972000 +0800
@@ -1,5 +1,6 @@
 #include <common.h>
 #include <exports.h>
+#include <cnc_util.h>
 
 DECLARE_GLOBAL_DATA_PTR;
 
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/hush.c u-boot-2011.06/common/hush.c
--- u-boot-2011.06_original/common/hush.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/common/hush.c	2014-09-05 13:44:03.861705000 +0800
@@ -1091,6 +1091,11 @@
 
 /* This is the magic location that prints prompts
  * and gets data back from the user */
+#ifdef CONFIG_INPUT_WHITELIST
+
+CONFIG_INPUT_WHITELIST
+
+#endif
 static int file_get(struct in_str *i)
 {
 	int ch;
@@ -1108,7 +1113,24 @@
 #else
 			while(! i->p  || strlen(i->p)==0 ) {
 #endif
+#ifdef CONFIG_INPUT_WHITELIST
+				do{
+					char **ptr, *whitelist_env;
+					get_user_input(i);
+					whitelist_env = getenv("WHITELIST");
+					if(whitelist_env != NULL && simple_strtoul(whitelist_env, NULL, 10)){
+						for(ptr = &input_whitelist[0];*ptr; ptr++){
+							if(!strncmp(i->p, *ptr, min(strlen(i->p), strlen(*ptr)))) break;
+						}
+
+						if(*ptr) break;
+					}else{
+						break;
+					}
+				}while(1);
+#else
 				get_user_input(i);
+#endif
 			}
 			i->promptmode=2;
 #ifndef __U_BOOT__
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/image.c u-boot-2011.06/common/image.c
